## AgsJackMidiin

AgsJackMidiin — Input from sequencer

## Stability Level

Stable, unless otherwise indicated

## Functions

#define | AGS_JACK_MIDIIN_GET_OBJ_MUTEX()
GQuark | ags_jack_midiin_error_quark ()
gboolean | ags_jack_midiin_test_flags ()
void | ags_jack_midiin_set_flags ()
void | ags_jack_midiin_unset_flags ()
void | ags_jack_midiin_switch_buffer_flag ()
AgsJackMidiin * | ags_jack_midiin_new ()

## Properties

gpointer | attack | Read
double | bpm | Read / Write
gpointer | buffer | Read
double | delay-factor | Read / Write
char * | device | Read / Write
AgsJackClient * | jack-client | Read / Write
AgsJackPort * | jack-port | Read / Write

## Types and Values

#define | AGS_JACK_MIDIIN_DEFAULT_APP_BUFFER_SIZE
#define | AGS_JACK_MIDIIN_DEFAULT_BUFFER_SIZE
enum | AgsJackMidiinFlags
enum | AgsJackMidiinAppBufferMode
enum | AgsJackMidiinSyncFlags
#define | AGS_JACK_MIDIIN_ERROR
enum | AgsJackMidiinError

## Object Hierarchy

        GFlags
        ╰── AgsJackMidiinFlags
        GObject
        ╰── AgsJackMidiin

## Includes

    #include <ags/audio/jack/ags_jack_midiin.h>

## Description

AgsJackMidiin represents a sequencer and supports midi input.

## Functions

### AGS_JACK_MIDIIN_GET_OBJ_MUTEX()

    #define AGS_JACK_MIDIIN_GET_OBJ_MUTEX(obj) (&(((AgsJackMidiin *) obj)->obj_mutex))

### ags_jack_midiin_error_quark ()

    GQuark
    ags_jack_midiin_error_quark ();

### ags_jack_midiin_test_flags ()

    gboolean
    ags_jack_midiin_test_flags (AgsJackMidiin *jack_midiin,
                                AgsJackMidiinFlags flags);

Test `flags` to be set on `jack_midiin` .

#### Parameters

jack_midiin | the AgsJackMidiin |
flags | the flags |

#### Returns

`TRUE` if flags are set, else `FALSE`

Since: 3.0.0

### ags_jack_midiin_set_flags ()

    void
    ags_jack_midiin_set_flags (AgsJackMidiin *jack_midiin,
                               AgsJackMidiinFlags flags);

Enable a feature of `jack_midiin` .

#### Parameters

jack_midiin | the AgsJackMidiin |
flags | see AgsJackMidiinFlags |

Since: 3.0.0

### ags_jack_midiin_unset_flags ()

    void
    ags_jack_midiin_unset_flags (AgsJackMidiin *jack_midiin,
                                 AgsJackMidiinFlags flags);

Disable a feature of `jack_midiin` .

#### Parameters

jack_midiin | the AgsJackMidiin |
flags | see AgsJackMidiinFlags |

Since: 3.0.0

### ags_jack_midiin_switch_buffer_flag ()

    void
    ags_jack_midiin_switch_buffer_flag (AgsJackMidiin *jack_midiin);

The buffer flag indicates the currently recorded buffer.

#### Parameters

jack_midiin | the AgsJackMidiin |

Since: 3.0.0

### ags_jack_midiin_new ()

    AgsJackMidiin *
    ags_jack_midiin_new ();

Creates a new instance of AgsJackMidiin.

#### Returns

the new AgsJackMidiin

Since: 3.0.0

## Types and Values

### AGS_JACK_MIDIIN_DEFAULT_APP_BUFFER_SIZE

    #define AGS_JACK_MIDIIN_DEFAULT_APP_BUFFER_SIZE (4)

### AGS_JACK_MIDIIN_DEFAULT_BUFFER_SIZE

    #define AGS_JACK_MIDIIN_DEFAULT_BUFFER_SIZE (256)

### enum AgsJackMidiinFlags

Enum values to control the behavior or indicate internal state of AgsJackMidiin by enable/disable as flags.

#### Members

AGS_JACK_MIDIIN_INITIALIZED | recording is initialized |
AGS_JACK_MIDIIN_START_RECORD | just started recording |
AGS_JACK_MIDIIN_RECORD | is recording |
AGS_JACK_MIDIIN_SHUTDOWN | stop recording |
AGS_JACK_MIDIIN_NONBLOCKING | do non-blocking calls |
AGS_JACK_MIDIIN_ATTACK_FIRST | use first attack, instead of second one |

### enum AgsJackMidiinAppBufferMode

Enum values to indicate internal state of AgsJackMidiin application buffer by setting mode.

#### Members

AGS_JACK_MIDIIN_APP_BUFFER_0 | ring-buffer 0 |
AGS_JACK_MIDIIN_APP_BUFFER_1 | ring-buffer 1 |
AGS_JACK_MIDIIN_APP_BUFFER_2 | ring-buffer 2 |
AGS_JACK_MIDIIN_APP_BUFFER_3 | ring-buffer 3 |

### enum AgsJackMidiinSyncFlags

Enum values to control the synchronization between sequencer and client.

#### Members

AGS_JACK_MIDIIN_PASS_THROUGH | do not sync |
AGS_JACK_MIDIIN_INITIAL_CALLBACK | initial callback |
AGS_JACK_MIDIIN_CALLBACK_WAIT | sync wait, sequencer conditional lock |
AGS_JACK_MIDIIN_CALLBACK_DONE | sync done, sequencer conditional lock |
AGS_JACK_MIDIIN_CALLBACK_FINISH_WAIT | sync wait, client conditional lock |
AGS_JACK_MIDIIN_CALLBACK_FINISH_DONE | sync done, client conditional lock |

### AGS_JACK_MIDIIN_ERROR

    #define AGS_JACK_MIDIIN_ERROR (ags_jack_midiin_error_quark())

### enum AgsJackMidiinError

#### Members

AGS_JACK_MIDIIN_ERROR_LOCKED_SOUNDCARD |  |

## Property Details

### The `“attack”` property

      “attack”                   gpointer

Attack of the buffer

Owner: AgsJackMidiin

Flags: Read

Since: 3.0.0

### The `“bpm”` property

      “bpm”                      double

Beats per minute

Owner: AgsJackMidiin

Flags: Read / Write

Allowed values: [1,240]

Default value: 120

Since: 3.0.0

### The `“buffer”` property

      “buffer”                   gpointer

The buffer

Owner: AgsJackMidiin

Flags: Read

Since: 3.0.0

### The `“delay-factor”` property

      “delay-factor”             double

tact

Owner: AgsJackMidiin

Flags: Read / Write

Allowed values: [0,16]

Default value: 1

Since: 3.0.0

### The `“device”` property

      “device”                   char *

The JACK sequencer indentifier

Owner: AgsJackMidiin

Flags: Read / Write

Default value: NULL

Since: 3.0.0

### The `“jack-client”` property

      “jack-client”              AgsJackClient *

The assigned AgsJackClient

Owner: AgsJackMidiin

Flags: Read / Write

Since: 3.0.0

### The `“jack-port”` property

      “jack-port”                AgsJackPort *

The assigned AgsJackPort

Owner: AgsJackMidiin

Flags: Read / Write

Since: 3.0.0